DECLARE SUB exec86 (BYVAL execloops AS LONG)
DECLARE SUB DiskHandler ()
DECLARE SUB InsertDisk (BYVAL DriveNum AS LONG, DiskFileName AS STRING)
DECLARE SUB finddrivecount ()
DECLARE SUB ReadDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
DECLARE SUB WriteDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
TYPE typeDrive
    'DiskFile AS STRING * 16
    Cylinders AS LONG
    Sectors AS LONG
    Heads AS LONG
    Inserted AS INTEGER
END TYPE

DIM SHARED Disk(&H83) AS typeDrive
DIM SHARED SectorBuffer AS STRING * 512
DECLARE SUB doirq (BYVAL irqnum AS LONG)
DECLARE SUB reset86 ()
DECLARE FUNCTION read86& (BYVAL addr32 AS LONG)
DECLARE SUB write86 (BYVAL addr32 AS LONG, BYVAL value AS LONG)
DECLARE SUB push (BYVAL pushval AS LONG)
DECLARE FUNCTION pop& ()
DECLARE FUNCTION makeflagsword& ()
DECLARE SUB decodeflagsword (BYVAL value AS LONG)
DECLARE FUNCTION signext& (BYVAL value AS INTEGER)
DECLARE FUNCTION readrm16& (BYVAL rmval AS INTEGER)
DECLARE FUNCTION readrm8& (BYVAL rmval AS INTEGER)
DECLARE SUB intcall86 (BYVAL intnum AS INTEGER)
DECLARE SUB flagszp8 (BYVAL value AS LONG)
DECLARE SUB flagszp16 (BYVAL value AS LONG)
DECLARE SUB flaglog8 (BYVAL value AS LONG)
DECLARE SUB flaglog16 (BYVAL value AS LONG)
DECLARE SUB flagadc8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagadc16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagadd8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagadd16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagsbb8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagsbb16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagsub8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagsub16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB opgrp1 (word&)
DECLARE FUNCTION opgrp28& (BYVAL cnt AS LONG)
DECLARE FUNCTION opgrp216& (BYVAL cnt AS LONG)
DECLARE SUB opdiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opdiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opidiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opidiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opgrp3 (BYVAL word&)
DECLARE SUB opgrp5 ()
DECLARE FUNCTION in8259& (BYVAL portnum AS LONG)
DECLARE SUB out8259 (BYVAL portnum AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION nextintr& ()
DECLARE SUB opadc8 ()
DECLARE SUB opadc16 ()
DECLARE SUB opadd8 ()
DECLARE SUB opadd16 ()
DECLARE SUB opand8 ()
DECLARE SUB opand16 ()
DECLARE SUB opor8 ()
DECLARE SUB opor16 ()
DECLARE SUB opxor8 ()
DECLARE SUB opxor16 ()
DECLARE SUB optest8 ()
DECLARE SUB optest16 ()
DECLARE SUB opsub8 ()
DECLARE SUB opsub16 ()
DECLARE SUB opsbb8 ()
DECLARE SUB opsbb16 ()
DECLARE SUB opcmp8 ()
DECLARE SUB opcmp16 ()
DECLARE SUB portout (BYVAL portval AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION portin& (BYVAL portval AS LONG)
DECLARE SUB LoadBinary (MemAddr AS LONG, FileName AS STRING, Writable AS ANY)
DECLARE SUB StepIP (BYVAL stepcount AS LONG)
DECLARE SUB writerm16 (BYVAL rmval AS LONG, BYVAL value AS LONG)
DECLARE SUB writerm8 (BYVAL rmval AS LONG, BYVAL value AS LONG)
DECLARE SUB putreg16 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE SUB putreg8 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE SUB modregrm ()
DECLARE SUB putsegreg (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION getmem8& (BYVAL segment AS LONG, BYVAL offset AS LONG)
DECLARE FUNCTION getmem16& (BYVAL segment AS LONG, BYVAL offset AS LONG)
DECLARE SUB putmem8 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
DECLARE SUB putmem16 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION getreg16& (BYVAL regnum AS INTEGER)
DECLARE FUNCTION getreg8& (BYVAL regnum AS INTEGER)
DECLARE FUNCTION getsegreg& (BYVAL regnum AS INTEGER)
DECLARE SUB getea (rmval&)
DECLARE FUNCTION shl& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
DECLARE FUNCTION shr& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
DECLARE FUNCTION hexpad$ (BYVAL hexvalue AS LONG, BYVAL padsize AS LONG)
DEFLNG A-Z

COMMON SHARED running, debugmode AS INTEGER
COMMON SHARED tempea, ea AS LONG
COMMON SHARED regah, regal, regbh, regbl, regch, regcl, regdh, regdl, opcode, segoverride, hltstate AS LONG
COMMON SHARED savecs, saveip, regsp, regbp, regsi, regdi, regcs, regds, regss, reges, ip, useseg AS LONG
COMMON SHARED cf, pf, af, zf, sf, tf, ifl, df, of, mode, reg, rm AS LONG
COMMON SHARED oper1, oper2, res16, disp16, temp16, val16 AS LONG
COMMON SHARED oper1b, oper2b, res8, disp8, temp8, val8 AS LONG
COMMON SHARED temp1, temp2, temp3, temp4, temp5, hdcount, vidmode AS LONG
COMMON SHARED temp32 AS LONG
COMMON SHARED result AS LONG
COMMON SHARED totalexec AS LONG
COMMON SHARED regax AS LONG
COMMON SHARED regcx AS LONG
COMMON SHARED regdx AS LONG
COMMON SHARED regbx AS LONG

TYPE pictype
    imr AS LONG
    irr AS LONG
    isr AS LONG
    icwstep AS LONG
    icw(4) AS LONG
    intoffset AS LONG
    priority AS LONG
    autoeoi AS LONG
    readmode AS LONG
    enabled AS LONG
END TYPE

COMMON SHARED i8259 AS pictype
COMMON SHARED keyboardwaitack AS INTEGER

SUB exec86 (BYVAL execloops AS LONG)
DIM loopcount, intval AS LONG
FOR loopcount = 1 TO execloops
        IF (ifl <> 0) THEN
          IF i8259.irr THEN
            IF (NOT i8259.imr) THEN
              intval = nextintr + 8
              hltstate = 0
              intcall86 intval
            END IF
          END IF
        END IF
        IF hltstate = 1 THEN GOTO skipexecute
        reptype = 0: segoverride = 0
        useseg = regds
        DO
                savecs = regcs: saveip = ip
                opcode = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&

                SELECT CASE opcode
        'segment prefix check
                        CASE &H2E 'segment regcs
            useseg = regcs: segoverride = 1
                        CASE &H3E 'segment regds
            useseg = regds: segoverride = 1
                        CASE &H26 'segment reges
            useseg = reges: segoverride = 1
                        CASE &H36 'segment regss
            useseg = regss: segoverride = 1

        'repetition prefix check
        CASE &HF3 'REP/REPE/REPZ
            reptype = 1
        CASE &HF2 'REPNE/REPNZ
            reptype = 2

        CASE ELSE
            EXIT DO
    END SELECT
        LOOP
        totalexec = totalexec + 1

        SELECT CASE opcode
                CASE &H0  '00 ADD Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b + oper2b
                        flagadd8 oper1b, oper2b
                        writerm8 rm, res8
                CASE &H1  '01 ADD Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        writerm16 rm, res16
                CASE &H2  '02 ADD Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b + oper2b
                        flagadd8 oper1b, oper2b
                        putreg8 reg, res8
                CASE &H3  '03 ADD Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        putreg16 reg, res16
                CASE &H4  '04 ADD regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b + oper2b
                        flagadd8 oper1b, oper2b
                        regal = res8
                CASE &H5  '05 ADD eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H6  '06 PUSH reges
                        push reges
                CASE &H7  '07 POP reges
                        reges = pop
                CASE &H8  '08 OR Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b OR oper2b
                        flaglog8 (res8)
                        writerm8 rm, res8
                CASE &H9  '09 OR Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 OR oper2
                        flaglog16 (res16)
                        writerm16 rm, res16
                CASE &HA  '0A OR Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b OR oper2b
                        flaglog8 (res8)
                        putreg8 reg, res8
                CASE &HB  '0B OR Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 OR oper2
                        flaglog16 (res16)
                        putreg16 reg, res16
                CASE &HC  '0C OR regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b OR oper2b
                        flaglog8 (res8)
                        regal = res8
                CASE &HD  '0D OR eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 OR oper2
                        flaglog16 (res16)
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &HE  '0E PUSH regcs
                        push regcs
                CASE &HF  '0F POP regcs
                        regcs = pop
                CASE &H10  '10 ADC Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b + oper2b + cf
                        flagadc8 oper1b, oper2b, cf
                        writerm8 rm, res8
                CASE &H11  '11 ADC Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 + oper2 + cf
                        flagadc16 oper1, oper2, cf
                        writerm16 rm, res16
                CASE &H12  '12 ADC Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b + oper2b + cf
                        flagadc8 oper1b, oper2b, cf
                        putreg8 reg, res8
                CASE &H13  '13 ADC Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 + oper2 + cf
                        flagadc16 oper1, oper2, cf
                        putreg16 reg, res16
                CASE &H14  '14 ADC regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b + oper2b + cf
                        flagadc8 oper1b, oper2b, cf
                        regal = res8
                CASE &H15  '15 ADC eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 + oper2 + cf
                        flagadc16 oper1, oper2, cf
                        regah = res16 \ 256: regal = res16 AND 255

                CASE &H16 '16 PUSH regss
                        push regss
                CASE &H17 '17 POP regss
                        regss = pop
                CASE &H18 '18 SBB Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b - (oper2b + cf)
                        flagsbb8 oper1b, oper2b, cf
                        writerm8 rm, res8
                CASE &H19 '19 SBB Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 - (oper2 + cf)
                        flagsbb16 oper1, oper2, cf
                        writerm16 rm, res16
                CASE &H1A '1A SBB Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b - (oper2b + cf)
                        flagsbb8 oper1b, oper2b, cf
                        putreg8 reg, res8
                CASE &H1B '1B SBB Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 - (oper2 + cf)
                        flagsbb16 oper1, oper2, cf
                        putreg16 reg, res16
                CASE &H1C '1C SBB regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b - (oper2b + cf)
                        flagsbb8 oper1b, oper2b, cf
                        regal = res8
                CASE &H1D '1D SBB eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 - (oper2 + cf)
                        flagsbb16 oper1, oper2, cf
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H1E '1E PUSH regds
                        push regds
                CASE &H1F '1F POP regds
                        regds = pop
                CASE &H20 '20 AND Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b AND oper2b
                        flaglog8 (res8)
                        writerm8 rm, res8
                CASE &H21 '21 AND Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 AND oper2
                        flaglog16 (res16)
                        writerm16 rm, res16
                CASE &H22 '22 AND Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b AND oper2b
                        flaglog8 (res8)
                        putreg8 reg, res8
                CASE &H23 '23 AND Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 AND oper2
                        flaglog16 (res16)
                        putreg16 reg, res16
                CASE &H24 '24 AND regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b AND oper2b
                        flaglog8 (res8)
                        regal = res8
                CASE &H25 '25 AND eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 AND oper2
                        flaglog16 (res16)
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H27 '27 DAA
        IF ((regal AND &HF&) > 9) OR (af = 1) THEN
            oper1 = regal + 6
            regal = oper1 AND 255
            IF (oper1 AND &HFF00&) THEN cf = 1 ELSE cf = 0
            af = 1
        ELSE
            af = 0
        END IF
        IF ((regal AND &HF0&) > &H90&) OR (cf = 1) THEN
            regal = regal + &H60&
            cf = 1
        ELSE
            cf = 0
        END IF
        regal = regal AND 255
        flagszp8 (regal)
                CASE &H28 '28 SUB Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b - oper2b
                        flagsub8 oper1b, oper2b
                        writerm8 rm, res8
                CASE &H29 '29 SUB Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        writerm16 rm, res16
                CASE &H2A '2A SUB Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b - oper2b
                        flagsub8 oper1b, oper2b
                        putreg8 reg, res8
                CASE &H2B '2B SUB Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        putreg16 reg, res16
                CASE &H2C '2C SUB regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b - oper2b
                        flagsub8 oper1b, oper2b
                        regal = res8
                CASE &H2D '2D SUB eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H2F '2F DAS
        IF ((regal AND 15) > 9) OR (af = 1) THEN
            oper1 = regal - 6
            regal = oper1 AND 255
            IF (oper1 AND &HFF00&) THEN cf = 1 ELSE cf = 0
            af = 1
        ELSE
            af = 0
        END IF
        IF ((regal AND &HF0&) > &H90&) OR (cf = 1) THEN
            regal = regal - &H60&
            cf = 1
        ELSE
            cf = 0
        END IF
        flagszp8 (regal)
                CASE &H30 '30 XOR Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        res8 = oper1b XOR oper2b
                        flaglog8 (res8)
                        writerm8 rm, res8
                CASE &H31 '31 XOR Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        res16 = oper1 XOR oper2
                        flaglog16 (res16)
                        writerm16 rm, res16
                CASE &H32 '32 XOR Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        res8 = oper1b XOR oper2b
                        flaglog8 (res8)
                        putreg8 reg, res8
                CASE &H33 '33 XOR Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        res16 = oper1 XOR oper2
                        flaglog16 (res16)
                        putreg16 reg, res16
                CASE &H34 '34 XOR regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        res8 = oper1b XOR oper2b
                        flaglog8 (res8)
                        regal = res8
                CASE &H35 '35 XOR eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        res16 = oper1 XOR oper2
                        flaglog16 (res16)
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H37 '37 AAA ASCII
        IF ((regal AND &HF&) > 9) OR (af = 1) THEN
            regal = regal + 6
            regah = regah + 1
            af = 1
            cf = 1
        ELSE
            af = 0
            cf = 0
        END IF
        regal = regal AND &HF&
                CASE &H38 '38 CMP Eb Gb
                        modregrm
                        oper1b = readrm8(rm): oper2b = getreg8(reg)
                        flagsub8 oper1b, oper2b
                CASE &H39 '39 CMP Ev Gv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getreg16(reg)
                        flagsub16 oper1, oper2
                CASE &H3A '3A CMP Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        flagsub8 oper1b, oper2b
                CASE &H3B '3B CMP Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        flagsub16 oper1, oper2
                CASE &H3C '3C CMP regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        flagsub8 oper1b, oper2b
                CASE &H3D '3D CMP eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        flagsub16 oper1, oper2
                CASE &H3F '3F AAS ASCII
        IF ((regal AND &HF&) > 9) OR (af = 1) THEN
            regal = regal - 6
            regah = regah - 1
            af = 1
            cf = 1
        ELSE
            af = 0
            cf = 0
        END IF
        regal = regal AND &HF&
                CASE &H40 '40 INC eAX
                        oldcf = cf
                        oper1 = ((regah * 256) + regal): oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H41 '41 INC eCX
                        oldcf = cf
                        oper1 = ((regch * 256) + regcl): oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        putreg16 regcx, res16
                CASE &H42 '42 INC eDX
                        oldcf = cf
                        oper1 = ((regdh * 256) + regdl): oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        putreg16 regdx, res16
                CASE &H43 '43 INC eBX
                        oldcf = cf
                        oper1 = ((regbh * 256) + regbl): oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        putreg16 regbx, res16
                CASE &H44 '44 INC eSP
                        oldcf = cf
                        oper1 = regsp: oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        regsp = res16
                CASE &H45 '45 INC eBP
                        oldcf = cf
                        oper1 = regbp: oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        regbp = res16
                CASE &H46 '46 INC eSI
                        oldcf = cf
                        oper1 = regsi: oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        regsi = res16
                CASE &H47 '47 INC eDI
                        oldcf = cf
                        oper1 = regdi: oper2 = 1
                        res16 = oper1 + oper2
                        flagadd16 oper1, oper2
                        cf = oldcf
                        regdi = res16
                CASE &H48 '48 DEC eAX
                        oldcf = cf
                        oper1 = ((regah * 256) + regal): oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H49 '49 DEC eCX
                        oldcf = cf
                        oper1 = ((regch * 256) + regcl): oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        putreg16 regcx, res16
                CASE &H4A '4A DEC eDX
                        oldcf = cf
                        oper1 = ((regdh * 256) + regdl): oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        putreg16 regdx, res16
                CASE &H4B '4B DEC eBX
                        oldcf = cf
                        oper1 = ((regbh * 256) + regbl): oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        putreg16 regbx, res16
                CASE &H4C '4C DEC eSP
                        oldcf = cf
                        oper1 = regsp: oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        regsp = res16
                CASE &H4D '4D DEC eBP
                        oldcf = cf
                        oper1 = regbp: oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        regbp = res16
                CASE &H4E '4E DEC eSI
                        oldcf = cf
                        oper1 = regsi: oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        regsi = res16
                CASE &H4F '4F DEC eDI
                        oldcf = cf
                        oper1 = regdi: oper2 = 1
                        res16 = oper1 - oper2
                        flagsub16 oper1, oper2
                        cf = oldcf
                        regdi = res16
                CASE &H50 '50 PUSH eAX
                        push ((regah * 256) + regal)
                CASE &H51 '51 PUSH eCX
                        push ((regch * 256) + regcl)
                CASE &H52 '52 PUSH eDX
                        push ((regdh * 256) + regdl)
                CASE &H53 '53 PUSH eBX
                        push ((regbh * 256) + regbl)
                CASE &H54 '54 PUSH eSP
                        push regsp - 2
                CASE &H55 '55 PUSH eBP
                        push regbp
                CASE &H56 '56 PUSH eSI
                        push regsi
                CASE &H57 '57 PUSH eDI
                        push regdi
                CASE &H58 '58 POP eAX
                   res16 = pop
                        regah = res16 \ 256: regal = res16 AND 255
                CASE &H59 '59 POP eCX
                   res16 = pop
                        regch = res16 \ 256: regcl = res16 AND 255
                CASE &H5A '5A POP eDX
                   res16 = pop
                        regdh = res16 \ 256: regdl = res16 AND 255
                CASE &H5B '5B POP eBX
                   res16 = pop
                        regbh = res16 \ 256: regbl = res16 AND 255
                CASE &H5C '5C POP eSP
                        regsp = getmem16(regss, regsp)
                CASE &H5D '5D POP eBP
                        regbp = pop
                CASE &H5E '5E POP eSI
                        regsi = pop
                CASE &H5F '5F POP eDI
                        regdi = pop

        CASE &H60
            oldsp = regsp
            push ((regah * 256) + regal)
            push ((regch * 256) + regcl)
            push ((regdh * 256) + regdl)
            push ((regbh * 256) + regbl)
            push oldsp
            push regbp
            push regsi
            push regdi

        CASE &H61
            regdi = pop
            regsi = pop
            regbp = pop
            regsp = pop
                   res16 = pop
                        regbh = res16 \ 256: regbl = res16 AND 255
                   res16 = pop
                        regdh = res16 \ 256: regdl = res16 AND 255
                   res16 = pop
                        regch = res16 \ 256: regcl = res16 AND 255
                   res16 = pop
                        regah = res16 \ 256: regal = res16 AND 255

        CASE &H68
            push getmem16(regcs, ip)
            ip = ip + 2

        CASE &H70 '70 JO Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF of <> 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H71 '71 JNO Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF of = 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H72 '72 JB Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF cf <> 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H73 '73 JNB Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF cf = 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H74 '74 JZ Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF zf <> 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H75 '75 JNZ Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF zf = 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H76 '76 JBE Jb
         temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (cf <> 0) OR (zf <> 0) THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H77 '77 JA Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (cf = 0) AND (zf = 0) THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H78 '78 JS Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF sf <> 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H79 '79 JNS Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF sf = 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7A '7A JPE Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF pf <> 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7B '7B JPO Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF pf = 0 THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7C '7C JL Jb
        temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (sf <> of) THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7D '7D JGE Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (sf = of) THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7E '7E JLE Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (sf <> of) OR (zf <> 0) THEN ip = (ip + temp16) AND &HFFFF&

    CASE &H7F '7F JG Jb
          temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
        IF (zf = 0) AND (sf = of) THEN ip = (ip + temp16) AND &HFFFF&
                CASE &H80, &H82 '80/82 GRP1 Eb Ib
                        modregrm
                        oper1b = readrm8(rm): oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        opgrp1 (0)
                        IF reg < 7 THEN
                                writerm8 rm, res8
                        END IF
                CASE &H81 '81 GRP1 Ev Iv
                        modregrm
                        oper1 = readrm16(rm): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        opgrp1 (1)
                        IF reg < 7 THEN
                                writerm16 rm, res16
                        END IF
                CASE &H83 '83 GRP1 Ev Ib
                        modregrm
                        oper1 = readrm16(rm): oper2 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                        opgrp1 (1)
                        IF reg < 7 THEN
                                writerm16 rm, res16
                        END IF
                CASE &H84 '84 TEST Gb Eb
                        modregrm
                        oper1b = getreg8(reg): oper2b = readrm8(rm)
                        flaglog8 (oper1b AND oper2b)
                CASE &H85 '85 TEST Gv Ev
                        modregrm
                        oper1 = getreg16(reg): oper2 = readrm16(rm)
                        flaglog16 (oper1 AND oper2)
                CASE &H86 '86 XCHG Gb Eb
                        modregrm
                        oper1b = getreg8(reg)
                        putreg8 reg, readrm8(rm)
                        writerm8 rm, oper1b
                CASE &H87 '87 XCHG Gv Ev
                        modregrm
                        oper1 = getreg16(reg)
                        putreg16 reg, readrm16(rm)
                        writerm16 rm, oper1
                CASE &H88 '88 MOV Eb Gb
                        modregrm
                        writerm8 rm, getreg8(reg)
                CASE &H89 '89 MOV Ev Gv
                        modregrm
                        writerm16 rm, getreg16(reg)
                CASE &H8A '8A MOV Gb Eb
                        modregrm
                        putreg8 reg, readrm8(rm)
                CASE &H8B '8B MOV Gv Ev
                        modregrm
                        putreg16 reg, readrm16(rm)
                CASE &H8C '8C MOV Ew Sw
                        modregrm
                        writerm16 rm, getsegreg(reg)
                CASE &H8D '8D LEA Gv M
                        modregrm
                        getea (rm)
                        putreg16 reg, ea - useseg * 16
                CASE &H8E '8E MOV Sw Ew
                        modregrm
                        putsegreg reg, readrm16(rm)
                CASE &H8F '8F POP Ev
                        modregrm
                        writerm16 rm, pop
                CASE &H90 '90 NOP
                CASE &H91 '91 XCHG eCX eAX
                        oper1b = regch
                        oper2b = regcl
                        regch = regah
                        regcl = regal
                        regah = oper1b
                        regal = oper2b
                CASE &H92 '92 XCHG eDX eAX
                        oper1b = regdh
                        oper2b = regdl
                        regdh = regah
                        regdl = regal
                        regah = oper1b
                        regal = oper2b
                CASE &H93 '93 XCHG eBX eAX
                        oper1b = regbh
                        oper2b = regbl
                        regbh = regah
                        regbl = regal
                        regah = oper1b
                        regal = oper2b
                CASE &H94 '94 XCHG eSP eAX
                        oper1 = regsp
                        regsp = ((regah * 256) + regal)
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &H95 '95 XCHG eBP eAX
                        oper1 = regbp
                        regbp = ((regah * 256) + regal)
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &H96 '96 XCHG eSI eAX
                        oper1 = regsi
                        regsi = ((regah * 256) + regal)
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &H97 '97 XCHG eDI eAX
                        oper1 = regdi
                        regdi = ((regah * 256) + regal)
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &H98 '98 CBW
                        IF (regal AND &H80) = &H80 THEN regah = &HFF ELSE regah = 0
                CASE &H99 '99 CWD
                        IF (regah AND &H80) = &H80 THEN
                                putreg16 regdx, &HFFFF
                        ELSE
                                putreg16 regdx, 0
                        END IF
                CASE &H9A '9A CALL Ap
                oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                push regcs: push ip: ip = oper1: regcs = oper2
                CASE &H9B '9B WAIT
                CASE &H9C '9C PUSHF
                        push makeflagsword AND &HFFFF&
                CASE &H9D '9D POPF
                        decodeflagsword pop
                CASE &H9E '9E SAHF
                        decodeflagsword (makeflagsword AND &HFF00&) + (regah AND &HFF&)
                CASE &H9F '9F LAHF
                        regah = makeflagsword AND &HFF
                CASE &HA0 'A0 MOV regal Ob
                        regal = getmem8(useseg, getmem16(regcs, ip)): ip = (ip + 2) AND &HFFFF&
                CASE &HA1 'A1 MOV eAX Ov
                        oper1 = getmem16(useseg, getmem16(regcs, ip)): ip = (ip + 2) AND &HFFFF&
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &HA2 'A2 MOV Ob regal
                        putmem8 useseg, getmem16(regcs, ip), regal: ip = (ip + 2) AND &HFFFF&
                CASE &HA3 'A3 MOV Ov eAX
                        putmem16 useseg, getmem16(regcs, ip), ((regah * 256) + regal): ip = (ip + 2) AND &HFFFF&
        CASE &HA4 'A4 MOVSB
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                putmem8 reges, regdi, getmem8(useseg, regsi)
                IF df THEN regsi = (regsi - 1) AND &HFFFF&: regdi = (regdi - 1) AND &HFFFF& ELSE regsi = (regsi + 1) AND &HFFFF&: regdi = (regdi + 1) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HA5 'A5 MOVSW
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                putmem16 reges, regdi, getmem16(useseg, regsi)
                IF df THEN regsi = (regsi - 2) AND &HFFFF&: regdi = (regdi - 2) AND &HFFFF& ELSE regsi = (regsi + 2) AND &HFFFF&: regdi = (regdi + 2) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HA6 'A6 CMPSB
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                oper1b = getmem8(useseg, regsi): oper2b = getmem8(reges, regdi)
                IF df THEN regsi = (regsi - 1) AND &HFFFF&: regdi = (regdi - 1) AND &HFFFF& ELSE regsi = (regsi + 1) AND &HFFFF&: regdi = (regdi + 1) AND &HFFFF&
                flagsub8 oper1b, oper2b
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                IF (reptype = 1) AND (zf = 0) THEN EXIT DO
                IF (reptype = 2) AND (zf = 1) THEN EXIT DO
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HA7 'A7 CMPSW
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                oper1 = getmem16(useseg, regsi): oper2 = getmem16(reges, regdi)
                IF df THEN regsi = (regsi - 2) AND &HFFFF&: regdi = (regdi - 2) AND &HFFFF& ELSE regsi = (regsi + 2) AND &HFFFF&: regdi = (regdi + 2) AND &HFFFF&
                flagsub16 oper1, oper2
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                IF (reptype = 1) AND (zf = 0) THEN EXIT DO
                IF (reptype = 2) AND (zf = 1) THEN EXIT DO
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0

                CASE &HA8 'A8 TEST regal Ib
                        oper1b = regal: oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        flaglog8 (oper1b AND oper2b)
                CASE &HA9 'A9 TEST eAX Iv
                        oper1 = ((regah * 256) + regal): oper2 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        flaglog16 (oper1 AND oper2)

        CASE &HAA 'AA STOSB
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                putmem8 reges, regdi, regal
                IF df THEN regdi = (regdi - 1) AND &HFFFF& ELSE regdi = (regdi + 1) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HAB 'AB STOSW
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                putmem16 reges, regdi, ((regah * 256) + regal)
                IF df THEN regdi = (regdi - 2) AND &HFFFF& ELSE regdi = (regdi + 2) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HAC 'AC LODSB
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                regal = getmem8(useseg, regsi)
                IF df THEN regsi = (regsi - 1) AND &HFFFF& ELSE regsi = (regsi + 1) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HAD 'AD LODSW
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                oper1 = getmem16(useseg, regsi)
                regah = (oper1 \ 256): regal = oper1 AND 255
                IF df THEN regsi = (regsi - 2) AND &HFFFF& ELSE regsi = (regsi + 2) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HAE 'AE SCASB
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                oper1b = getmem8(reges, regdi): oper2b = regal
                flagsub8 oper1b, oper2b
                IF df THEN regdi = (regdi - 1) AND &HFFFF& ELSE regdi = (regdi + 1) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                IF (reptype = 1) AND (zf = 0) THEN EXIT DO
                IF (reptype = 2) AND (zf = 1) THEN EXIT DO
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0
        CASE &HAF 'AF SCASW
            DO
                IF (reptype <> 0) AND (((regch * 256) + regcl) = 0) THEN EXIT DO
                oper1 = getmem16(reges, regdi): oper2 = ((regah * 256) + regal)
                flagsub16 oper1, oper2
                IF df THEN regdi = (regdi - 2) AND &HFFFF& ELSE regdi = (regdi + 2) AND &HFFFF&
                IF (reptype <> 0) THEN
                    putreg16 regcx, (((regch * 256) + regcl) - 1) AND &HFFFF&
                END IF
                IF (reptype = 1) AND (zf = 0) THEN EXIT DO
                IF (reptype = 2) AND (zf = 1) THEN EXIT DO
                totalexec = totalexec + 1
            LOOP UNTIL reptype = 0

                CASE &HB0 'B0 MOV regal Ib
                        regal = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB1 'B1 MOV regcl Ib
                        regcl = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB2 'B2 MOV regdl Ib
                        regdl = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB3 'B3 MOV regbl Ib
                        regbl = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB4 'B4 MOV regah Ib
                        regah = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB5 'B5 MOV regch Ib
                        regch = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB6 'B6 MOV regdh Ib
                        regdh = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB7 'B7 MOV regbh Ib
                        regbh = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HB8 'B8 MOV eAX Iv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        regah = oper1 \ 256: regal = oper1 AND 255
                CASE &HB9 'B9 MOV eCX Iv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        regch = oper1 \ 256: regcl = oper1 AND 255
                CASE &HBA 'BA MOV eDX Iv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        regdh = oper1 \ 256: regdl = oper1 AND 255
                CASE &HBB 'BB MOV eBX Iv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        regbh = oper1 \ 256: regbl = oper1 AND 255
                CASE &HBC 'BC MOV eSP Iv
                        regsp = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                CASE &HBD 'BD MOV eBP Iv
                        regbp = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                CASE &HBE 'BE MOV eSI Iv
                        regsi = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                CASE &HBF 'BF MOV eDI Iv
                        regdi = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                CASE &HC0 'C0 GRP2 byte imm8 (80186+)
                        modregrm
                        oper1b = readrm8(rm)
                        oper2b = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        writerm8 rm, opgrp28(oper2b)

                CASE &HC1 'C1 GRP2 word imm8 (80186+)
                        modregrm
                        oper1 = readrm16(rm)
                        oper2 = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        writerm16 rm, opgrp216(oper2)

                CASE &HC2 'C2 RET Iw
                        oper1 = getmem16(regcs, ip)
                        ip = pop
                        regsp = regsp + oper1

                CASE &HC3 'C3 RET
                        ip = pop
                CASE &HC4 'C4 LES Gv Mp
        modregrm
        getea (rm)
        putreg16 reg, read86(ea) + read86(ea + 1) * 256
        reges = read86(ea + 2) + read86(ea + 3) * 256
                CASE &HC5 'C5 LDS Gv Mp
        modregrm
        getea (rm)
        putreg16 reg, read86(ea) + read86(ea + 1) * 256
        regds = read86(ea + 2) + read86(ea + 3) * 256
                CASE &HC6 'C6 MOV Eb Ib
                        modregrm
                        writerm8 rm, getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                CASE &HC7 'C7 MOV Ev Iv
                        modregrm
                        writerm16 rm, getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&

        CASE &HC8 'C8 ENTER (80186+)
                  stacksize = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
          nestlev = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
          push regbp
          frametemp = regsp
                  IF nestlev <> 0 THEN
                        FOR temp16 = 1 TO nestlev - 1
                                regbp = regbp - 2
                                push regbp
                        NEXT temp16
                        push regsp
                  END IF
                  regbp = frametemp
                  regsp = regbp - stacksize

        CASE &HC9 'C9 LEAVE (80186+)
             regsp = regbp
             regbp = pop

                CASE &HCA 'CA RETF Iw
                        oper1 = getmem16(regcs, ip)
                        ip = pop: regcs = pop
                        regsp = regsp + oper1
                CASE &HCB 'CB RETF
                        ip = pop: regcs = pop
                CASE &HCC 'CC INT 3
                        intcall86 3
                CASE &HCD 'CD INT Ib
                        oper1 = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
                        intcall86 oper1
                CASE &HCE 'CE INTO
                        IF of THEN intcall86 4
                CASE &HCF 'CF IRET
                        ip = pop: regcs = pop
                        decodeflagsword pop
                CASE &HD0 'D0 GRP2 Eb 1
                        modregrm
                        oper1b = readrm8(rm)
                        writerm8 rm, opgrp28(1)
                CASE &HD1 'D1 GRP2 Ev 1
                        modregrm
                        oper1 = readrm16(rm)
                        writerm16 rm, opgrp216(1)
                CASE &HD2 'D2 GRP2 Eb regcl
                        modregrm
                        oper1b = readrm8(rm)
                        writerm8 rm, opgrp28(regcl)
                CASE &HD3 'D3 GRP2 Ev regcl
                        modregrm
                        oper1 = readrm16(rm)
                        writerm16 rm, opgrp216(regcl)
                CASE &HD4 'D4 AAM I0
        oper1 = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
        IF oper1 = 0 THEN intcall86 0: EXIT SUB 'division by zero
        regah = (regal \ oper1) AND 255
        regal = (regal MOD oper1) AND 255
        flagszp16 ((regah * 256) + regal)

                CASE &HD5 'D5 AAD I0
        oper1 = getmem8(regcs, ip): ip = (ip + 1) AND &HFFFF&
        regal = (regah * oper1 + regal) AND 255
        regah = 0
        flagszp16 (regah * oper1 + regal)
        sf = 0
                CASE &HD7 'D7 XLAT
                        regal = read86(useseg * 16 + ((regbh * 256) + regbl) + regal)
                CASE &HD8 TO &HDF 'escape
                        modregrm
                CASE &HE0 'E0 LOOPNZ Jb
        temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                putreg16 regcx, ((regch * 256) + regcl) - 1
                IF (((regch * 256) + regcl) <> 0) AND (zf = 0) THEN ip = (ip + temp16) AND &HFFFF&

                CASE &HE1 'E1 LOOPZ Jb
                temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                putreg16 regcx, ((regch * 256) + regcl) - 1
                IF (((regch * 256) + regcl) <> 0) AND (zf = 1) THEN ip = (ip + temp16) AND &HFFFF&

                CASE &HE2 'E2 LOOP Jb
        temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                putreg16 regcx, ((regch * 256) + regcl) - 1
                IF ((regch * 256) + regcl) <> 0 THEN ip = (ip + temp16) AND &HFFFF&

                CASE &HE3 'E3 JCXZ Jb
        temp16 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                IF ((regch * 256) + regcl) = 0 THEN ip = (ip + temp16) AND &HFFFF&

                CASE &HE4 'E4 IN regal Ib
        oper1b = getmem8(regcs, ip)
        ip = (ip + 1) AND &HFFFF&
        regal = portin(oper1b)
                CASE &HE5 'E5 IN eAX Ib
        oper1b = getmem8(regcs, ip)
        ip = (ip + 1) AND &HFFFF&
        putreg16 regax, portin(oper1b)
                CASE &HE6 'E6 OUT Ib regal
        oper1b = getmem8(regcs, ip)
        ip = (ip + 1) AND &HFFFF&
        portout16 = 0
                portout oper1b, regal
                CASE &HE7 'E7 OUT Ib eAX
        oper1b = getmem8(regcs, ip)
        ip = (ip + 1) AND &HFFFF&
        portout16 = 1
        portout oper1b, ((regah * 256) + regal)

                CASE &HE8 'E8 CALL Jv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        push ip
                        ip = (ip + oper1) AND &HFFFF&
                CASE &HE9 'E9 JMP Jv
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        ip = (ip + oper1) AND &HFFFF&
                CASE &HEA 'EA JMP Ap
                        oper1 = getmem16(regcs, ip): ip = (ip + 2) AND &HFFFF&
                        oper2 = getmem16(regcs, ip)
                        ip = oper1: regcs = oper2
                CASE &HEB 'EB JMP Jb
                        oper1 = signext(getmem8(regcs, ip)): ip = (ip + 1) AND &HFFFF&
                        ip = (ip + oper1) AND &HFFFF&
                CASE &HEC 'EC IN regal regdx
        oper1 = ((regdh * 256) + regdl)
        regal = portin(oper1)
                CASE &HED 'ED IN eAX regdx
        oper1 = ((regdh * 256) + regdl)
        putreg16 regax, portin(oper1)
                CASE &HEE 'EE OUT regdx regal
        oper1 = ((regdh * 256) + regdl)
        portout16 = 0
        portout oper1, regal
                CASE &HEF 'EF OUT regdx eAX
        oper1 = ((regdh * 256) + regdl)
        portout16 = 1
        portout oper1, ((regah * 256) + regal)
                CASE &HF0 'F0 LOCK
                CASE &HF4 'F4 HLT
                        hltstate = 1
                CASE &HF5 'F5 CMC
                        IF cf = 0 THEN cf = 1 ELSE cf = 0
                CASE &HF6 'F6 GRP3a Eb
        modregrm
        oper1b = readrm8(rm)
        opgrp3 (0)
        IF (reg > 1) AND (reg < 4) THEN
                        writerm8 rm, res8
        END IF

                CASE &HF7 'F7 GRP3b Ev
        modregrm
        oper1 = readrm16(rm)
        opgrp3 (1)
        IF (reg > 1) AND (reg < 4) THEN
                        writerm16 rm, res16
        END IF
                CASE &HF8 'F8 CLC
                        cf = 0
                CASE &HF9 'F9 STC
                        cf = 1
                CASE &HFA 'FA CLI
                        ifl = 0
                CASE &HFB 'FB STI
                        ifl = 1
                CASE &HFC 'FC CLD
                        df = 0
                CASE &HFD 'FD STD
                        df = 1
                CASE &HFE 'FE GRP4 Eb
        modregrm
        oper1b = readrm8(rm): oper2b = 1
        IF reg = 0 THEN
            temp = cf
                                res8 = oper1b + oper2b
                        flagadd8 oper1b, oper2b
            cf = temp: writerm8 rm, res8
        ELSEIF reg = 1 THEN
            temp = cf
                                res8 = oper1b - oper2b
                        flagsub8 oper1b, oper2b
            cf = temp: writerm8 rm, res8
        END IF
                CASE &HFF 'FF GRP5 Ev
        modregrm
        oper1 = readrm16(rm)
        opgrp5
        CASE ELSE
                 '       intcall86 6
        END SELECT
skipexecute:
        IF running = 0 THEN EXIT FOR
NEXT loopcount
END SUB

